<?php if(!defined('PmWiki')) exit();

 /**
 *  Copyright 2011 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/// CSSCOMPRESS - Compresses skin and recipe css files.

/// VARIABLES

$RecipeInfo['csscompress']['version'] = '20110402';

$HandleActions['csscompress'] = 'HandleCssCompress';
$HandleAuth['csscompress'] = 'admin';

SDV($CssCompressRgbPat , "/rgb\(\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?,\s?([0-9]{1,3})\s?\)/e");
SDV($CssCompressHexPat , "/#([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})/e");
SDV($CssCompressCommentPat , '!/\*[^*]*\*+([^/][^*]*\*+)*/!');
SDV($CssCompressTabReturnNewline, array("\t", "\r", "\n"));
SDV($CssCompressSpacePat , '/\s{1,10}/');
SDV($CssCompressMoreSpace , array(
  '! important' => '!important',
  ' {' => '{' , '{ ' => '{',
  '} ' => '}' , ' }' => '}',
  '( ' => '(' , ' (' => '(',
  ') ' => ')' , ' )' => ')',
  ' ,' => ',' , ', ' => ',',
  ' :' => ':' , ': ' => ':',
  ' ;' => ';' , '; ' => ';',
  ';}' => '}'
));
SDV($CssCompressColor,array(
  'black' =>'#000',
  'fuchsia' => '#f0f',
  // workaround for
  // white-space selector 
  ':white' => ':#fff',
  ' white' => ' #fff', 
  'yellow' => '#FF0',
  '#800000' => 'maroon',
  '#ffa500' => 'orange',
  '#808000' => 'olive',
  '#800080' => 'purple',
  '#008000' => 'green',
  '#000080' => 'navy',
  '#008080' => 'teal',
  '#c0c0c0' => 'silver',
  '#808080' => 'gray',
  '#f00' => 'red'
));
SDV($CssCompressFontWeight, array(
  'font-weight:bold' => 'font-weight:700',
  'font-weight:normal' => 'font-weight:400'
));
SDV($CssCompressOverWrite , true);
// complete or relative path to files
// don't forget to check file permissions
// I decided not to touch it from here
// it also accepts anything that
// can be replaced by FmtPageName
SDV($CssCompressFiles , array(
  './pub/skins/pmwiki/pmwiki.css' => './pub/skins/pmwiki/pmwiki.cmp.css'
));

// message to show
// as part of the page
// when csscompress is called
SDV($CssCompressMessage, '
(:title Action -> Css Compress :)
(:div style="text-align:center":)
You have to fill the array called $CssCompressFiles so this action can work.[[<<]]
Click the link bellow to see some action![[<<]]
[[{$ScriptUrl}?n={$FullName}&action=csscompress| CSS COMPRESS]] [[<<]]
[[<<]]
You can change this message editing the var called $CssCompressMessage[[<<]]
(:divend:)
----[[<<]]'
);

/// FUNCTIONS

function CssCompressFirst($c){
  if($c{0} == " ")
    $c = substr($c,1);
  return $c;
}

function CssCompressUnit($c){
  $units = "(px|ex|em|pt)";
  $c = preg_replace("/\:0{1,10}$units/",":0",$c);
  $c = preg_replace("/\s0{1,10}$units/"," 0",$c);
  $c = preg_replace("/0{1,10}[\.,]([0-9]{1})([0-9]{0,10})$units/",".$1$2$3",$c);
  $c = preg_replace("/([0-9]{1,10})?([0-9]{1,10})[,]([0-9]{1})([0-9]{0,10})$units/","$1$2.$3$4$5",$c);
  return $c;
}

function CssCompressLowerPropertie($c){
 $c = preg_replace("/([\{;][a-zA-Z\-]{1,30}\:)/e","strtolower('$1')",$c);
 return $c;
}

function CssCompressProperties2Array($c){
 $x = explode(';',$c);
  foreach($x as $k => $v){
    if($v != ''){
      $y = '';
      $y = explode(':',$v);
      $z[$y[0]] = $y[1];
    }
  }
  return $z;
}

function CssCompressShortHand($c){
$p = '/\{(.*)\}/e';
// so we don't get trapped
// by @media rules
$r = array("{"=>"\n{","}"=>"}\n");
$z = str_replace(array_keys($r),array_values($r),$c);
$z = preg_replace($p,"CssCompressShortHandList(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandFont(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandBorder(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandMargin(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandMargin2(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandPadding(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandPadding2(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandOutline(PSS('$1'))",$z);
$z = preg_replace($p,"CssCompressShortHandBackground(PSS('$1'))",$z);
$z = str_replace(array_values($r),array_keys($r),$z);
return $z;
}

function CssCompressShortHandList($c){

//  2 properties with different
// values, the last one takes precedence

$r = CssCompressProperties2Array($c);

if($r['list-style-type'] != '' &&
   $r['list-style-image'] != ''  &&
   $r['list-style-position'] != '' ){

   $r['list-style'] =  $r['list-style-type']." ".
             $r['list-style-position']." ".
             $r['list-style-image'];

   foreach($r as $k => $v){
     if($k == 'list-style-type' ||
        $k == 'list-style-image' ||
        $k == 'list-style-position'){
     continue;
     }else{
        @$f .= $k.":".$v.";";
     }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandFont($c){
$r = CssCompressProperties2Array($c);

if($r['font-style'] != '' &&  $r['font-variant'] != ''  &&
   $r['font-weight'] != ''  &&  $r['font-size'] != ''  &&
   $r['line-height'] != ''  &&  $r['font-family'] != '' ){

   $r['font'] =  $r['font-style']." ".$r['font-variant']." ".
             $r['font-weight']." ".$r['font-size']." ".
             $r['line-height']." ".$r['font-family'];

   foreach($r as $k => $v){
     if($k == 'font-style' || $k == 'font-variant' ||
        $k == 'font-weight' || $k == 'font-size' ||
        $k == 'line-height' || $k == 'font-family'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandBorder($c){
$r = CssCompressProperties2Array($c);

if($r['border-width'] != '' && $r['border-style'] != ''  &&
   $r['border-color'] != '' ){

   $r['border'] =  $r['border-width']." ".$r['border-style']." ".
             $r['border-color'];

   foreach($r as $k => $v){
     if($k == 'border-width' || $k == 'border-style' ||
        $k == 'border-color'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandMargin($c){
$r = CssCompressProperties2Array($c);

if($r['margin-top'] != '' && $r['margin-right'] != ''  &&
   $r['margin-bottom'] != ''  && $r['margin-left'] != '' ){

   $r['margin'] =  $r['margin-top']." ".$r['margin-right']." ".
             $r['margin-bottom']." ".$r['margin-left'];

   foreach($r as $k => $v){
     if($k == 'margin-top' || $k == 'margin-right' ||
        $k == 'margin-bottom' || $k == 'margin-left'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandMargin2($c){
$r = CssCompressProperties2Array($c);

if($r['margin'] != '' ){
   $t = explode(' ', $r['margin']);
   if($t[0] == $t[1] && $t[0] == $t[2] &&
      $t[0] == $t[3]){
     $r['margin'] = $t[0];
   }

   foreach($r as $k => $v){
      @$f .= $k.":".$v.";"; }
   $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandPadding($c){
$r = CssCompressProperties2Array($c);

if($r['padding-top'] != '' && $r['padding-right'] != ''  &&
   $r['padding-bottom'] != ''  && $r['padding-left'] != '' ){

   $r['padding'] =  $r['padding-top']." ".$r['padding-right']." ".
             $r['padding-bottom']." ".$r['padding-left'];

   foreach($r as $k => $v){
     if($k == 'padding-top' || $k == 'padding-right' ||
        $k == 'padding-bottom' || $k == 'padding-left'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandPadding2($c){
$r = CssCompressProperties2Array($c);

if($r['padding'] != '' ){
   $t = explode(' ', $r['padding']);
   if($t[0] == $t[1] && $t[0] == $t[2] &&
      $t[0] == $t[3]){
     $r['padding'] = $t[0];
   }

   foreach($r as $k => $v){
      @$f .= $k.":".$v.";"; }
   $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandOutline($c){
$r = CssCompressProperties2Array($c);

if($r['outline-width'] != '' && $r['outline-style'] != ''  &&
   $r['outline-color'] != '' ){

   $r['outline'] =  $r['outline-width']." ".$r['outline-style']." ".
             $r['outline-color'];

   foreach($r as $k => $v){
     if($k == 'outline-width' || $k == 'outline-style' ||
        $k == 'outline-color'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHandBackground($c){
$r = CssCompressProperties2Array($c);

if($r['background-color'] != '' && $r['background-image'] != ''  &&
   $r['background-repeat'] != ''  && $r['background-position'] != ''  &&
   $r['background-attachment'] != '' ){

   $r['background'] =  $r['background-color']." ".$r['background-image']." ".
             $r['background-repeat']." ".$r['background-position']." ".
             $r['background-attachment'];

   foreach($r as $k => $v){
     if($k == 'background-color' || $k == 'background-image' ||
        $k == 'background-repeat' ||$k == 'background-position' ||
        $k == 'background-attachment'){
     continue;
     }else{ @$f .= $k.":".$v.";"; }
   }

  $c = substr($f,0,-1);
}

$c = "{".$c."}";
return $c;
}

function CssCompressShortHex($r,$g,$b){
  $r1 = substr($r,0,1);$r2= substr($r,1,2); 
  if($r1 == $r2) $re = 1; else $re = 0;
  $g1 = substr($g,0,1);$g2= substr($g,1,2); 
  if($g1 == $g2) $ge = 1;else $ge = 0;
  $b1 = substr($b,0,1);$b2= substr($b,1,2); 
  if($b1 == $b2) $be = 1;else $be = 0;
  if($re == 1 && $ge == 1 && $be == 1 ){
    $out = "#".$r1.$g1.$b1 ;
  }else{
    $out = "#".$r.$g.$b;
  }
  return strtolower($out);
}

function CssCompressRgb2Hex($r,$g,$b){
  $r = dechex($r);$g = dechex($g);$b = dechex($b);
  return CssCompressShortHex($r,$g,$b);
}

function CssCompress($buffer) {
  global $CssCompressRgbPat,$CssCompressHexPat,$CssCompressCommentPat,
    $CssCompressTabReturnNewline,$CssCompressSpacePat,
    $CssCompressMoreSpace,$CssCompressColor,
    $CssCompressFontWeight;

  // remove comments
  $buffer = preg_replace($CssCompressCommentPat, '', $buffer);

  // remove tabs, return, newlines and combinations.
  $buffer = str_replace($CssCompressTabReturnNewline,'', $buffer);

  // replace spaces with just one space
  $buffer = preg_replace($CssCompressSpacePat,' ', $buffer);

  // more spaces
  $buffer = str_replace(array_keys($CssCompressMoreSpace),
                        array_values($CssCompressMoreSpace), $buffer);

  // string to lower selectors
  $buffer = CssCompressLowerPropertie($buffer);

  // transforms rgb(126,100,88) in #773344 and to short #734 colors
  $buffer = preg_replace($CssCompressRgbPat,
                   'CssCompressRgb2Hex("$1","$2","$3")',$buffer);

  // transforms  #334455 to short #345 colors
  $buffer = preg_replace($CssCompressHexPat,
                   'CssCompressShortHex("$1","$2","$3")',$buffer);

  // more color compression
  $buffer = str_replace(array_keys($CssCompressColor),
                        array_values($CssCompressColor), $buffer);

  // font weight compression
  $buffer = str_replace(array_keys($CssCompressFontWeight),
                        array_values($CssCompressFontWeight), $buffer);

  // unit compression
  $buffer = CssCompressUnit($buffer);

  // short hand compression
  $buffer = CssCompressShortHand($buffer);

  // first space character removal
  $buffer = CssCompressFirst($buffer);

  return $buffer;
}

/// HANDLER

function HandleCssCompress($pagename,$auth='admin'){
  global $CssCompressOverWrite,$CssCompressFiles,
         $CssCompressMessage,$PageStartFmt,$PageEndFmt;

  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  if (!$page) Abort("Insufficient permissions for Css Compress");

  $msg = MarkupToHTML($pagename,$CssCompressMessage);
  foreach($CssCompressFiles as $k => $v){
    $infile = FmtPageName($k, $pagename);
    $outfile = FmtPageName($v, $pagename);
    if(!file_exists($infile)){
      $msg .= "$[Css infile does not exist] -> ".$infile."<br/>\n";
    }else{
      $writeperm = false;
      if(file_exists($outfile) &&
            $CssCompressOverWrite == true) $writeperm = true;
      if($writeperm == false)
        $msg .= "$[Css outfile couldn't be created] -> ".$outfile."<br/>\n";
      if(!($csscontents = file_get_contents($infile)))
        $msg .= "$[Couldn't open css infile for compression] -> ".$infile."<br/>\n";
      if(!($csscompressed = CssCompress($csscontents))) 
        $msg .= "$[Couldn't compress the opened css infile] -> ".$infile."<br/>\n";
      if($csscontents != '' && $writeperm == true){
        if(!file_put_contents($outfile,$csscompressed))
          $msg .= "$[Couldn't open outfile] -> ".$outfile.".\n";
        else $msg .= $infile." - $[File compressed and saved in] -> ".$outfile."<br/>\n";
      }
    }
  }

  $PageCssCompressFmt = "<div>".FmtPageName($msg, $pagename)."</div>";
  SDV($HandleCssCompressFmt, array(&$PageStartFmt, &$PageCssCompressFmt, &$PageEndFmt));
  PrintFmt($pagename, $HandleCssCompressFmt);
}
